\begin{ManPage}{\label{man-condor-status}\Condor{status}}{1}
{Display status of the HTCondor pool}
\index{HTCondor commands!condor\_status}
\index{condor\_status command}

\Synopsis \SynProg{\Condor{status}}
\ToolDebugOption
\oArg{help options}
\oArg{query options}
\oArg{display options}
\oArg{custom options}
\oArg{name \Dots}

\Description
\Condor{status} is a versatile tool that may be used to monitor and query the 
HTCondor pool.  The \Condor{status} tool can be used to query resource 
information, submitter information, checkpoint server information, and daemon
master information.  The specific query sent and the resulting information 
display is controlled by the query options supplied.  Queries and display 
formats can also be customized.

The options that may be supplied to \Condor{status} belong to five groups:
\begin{itemize}
	\item \textbf{Help options} provide information about the \Condor{status}
		tool.
	\item \textbf{Query options} control the content and presentation of status
		information.
	\item \textbf{Display options} control the display of the queried 
		information.
	\item \textbf{Custom options} allow the user to customize query and
		display information.
	\item \textbf{Host options} specify specific machines to be queried
\end{itemize}

At any time, only one \Arg{help option}, one \Arg{query option} and one
\Arg{display option} may be specified.  
Any number of \Arg{custom options} and \Arg{host options} may be specified.

\begin{Options}
    \ToolDebugDesc
    \OptItem{\Opt{-help}}{(Help option) Display usage information.}
    \OptItem{\Opt{-diagnose}}{(Help option) Print out ClassAd query without 
      performing the query.}
    \OptItem{\Opt{-absent}}{(Query option) Query for and display only 
      absent resources.}
    \OptItem{\OptArg{-ads}{filename}}{(Query option) Read the set of 
      ClassAds in the file specified by \Arg{filename},
      instead of querying the \Condor{collector}.}
    \OptItem{\Opt{-any}}{(Query option) Query all ClassAds and display 
      their type, target type, and name.}
    \OptItem{\Opt{-avail}}{(Query option) Query \Condor{startd} ClassAds 
      and identify resources which are available.}
    \OptItem{\Opt{-ckptsrvr}}{(Query option) Query \Condor{ckpt\_server} 
      ClassAds and display checkpoint server attributes.}
    \OptItem{\Opt{-claimed}}{(Query option) Query \Condor{startd} ClassAds 
      and print information about claimed resources.}
    \OptItem{\Opt{-cod}}{(Query option) Display only machine ClassAds
      that have COD claims. Information displayed includes
      the claim ID, the owner of the claim, and the state
      of the COD claim.}
    \OptItem{\Opt{-collector}}{(Query option) Query \Condor{collector} ClassAds
      and display attributes.}
    \OptItem{\Opt{-defrag}}{(Query option) Query \Condor{defrag} ClassAds.} 
    \OptItem{\OptArg{-direct}{hostname}}{(Query option) Go directly to
      the given host name to get the ClassAds to display.  
      By default, returns the \Condor{startd} ClassAd.  
      If \Opt{-schedd} is also given, return the \Condor{schedd} ClassAd
      on that host.}
    \OptItem{\Opt{-java}}{(Query option) Display only Java-capable resources.}
    \OptItem{\Opt{-license}}{(Query option) Display license attributes.}
    \OptItem{\Opt{-master}}{(Query option) Query \Condor{master} ClassAds 
      and display daemon master attributes.}
    \OptItem{\Opt{-negotiator}}{(Query option) Query \Condor{negotiator} 
      ClassAds and display attributes.}
    \OptItem{\OptArg{-pool}{centralmanagerhostname[:portnumber]}}
      {(Query option) Query the specified central manager using an
      optional port number. 
      \Condor{status} queries the machine specified by the configuration
      variable \MacroNI{COLLECTOR\_HOST} by default.}
    \OptItem{\Opt{-run}}{(Query option) Display information about machines
      currently running jobs.}
    \OptItem{\Opt{-schedd}}{(Query option) Query \Condor{schedd} ClassAds 
      and display attributes.}
    \OptItem{\Opt{-server}}{(Query option) Query \Condor{startd} ClassAds and 
      display resource attributes.}
    \OptItem{\Opt{-startd}}{(Query option) Query \Condor{startd} ClassAds.} 
    \OptItem{\Opt{-state}}{(Query option) Query \Condor{startd} ClassAds 
      and display resource state information.}
    \OptItem{\OptArg{-statistics}{WhichStatistics}}{(Query option) Can only be
      used if the \Opt{-direct} option has been specified.
      Identifies which Statistics attributes to include in the ClassAd.
      \Arg{WhichStatistics} is specified using the same syntax as defined 
      for \MacroNI{STATISTICS\_TO\_PUBLISH}.  A definition is in the
      HTCondor Administrator's manual section on configuration.}
    \OptItem{\Opt{-storage}}{(Query option) Display attributes of machines
      with network storage resources.}
    \OptItem{\Opt{-submitters}}{(Query option) Query ClassAds sent by 
      submitters and display important submitter attributes.}
    \OptItem{\OptArg{-subsystem}{type}}{(Query option) If \Arg{type} is
      one of \Arg{collector}, \Arg{negotiator}, \Arg{master},
      \Arg{schedd}, \Arg{startd}, or \Arg{quill},
      then behavior is the same as the query option without the
      \Opt{-subsystem} option.  For example,
      \OptArg{-subsystem}{collector} is the same as \Opt{-collector}.
      A value of \Arg{type} of \Arg{CkptServer},
      \Arg{Machine}, \Arg{DaemonMaster}, or \Arg{Scheduler}
      targets that type of ClassAd.  }
    \OptItem{\Opt{-vm}}{(Query option) Query \Condor{startd} ClassAds,
      and display only VM-enabled machines.  Information displayed includes
      the machine name, the virtual machine software version,
      the state of machine, the virtual machine memory,
      and the type of networking.}
    \OptItem{\Opt{-offline}}{(Query option) Query \Condor{startd} ClassAds,
      and display, for each machine with at least one offline universe,
      which universes are offline for it.}
    \OptItem{\OptArg{-attributes}{Attr1[,Attr2 \Dots]}}{(Display option)
      Explicitly list the attributes in a comma separated list
      which should be displayed when using the \Opt{-xml} or \Opt{-long}
      options.  Limiting the number of attributes increases the efficiency 
      of the query.}  
    \OptItem{\Opt{-expert}}{(Display option) Display shortened error messages.}
    \OptItem{\Opt{-long}}{(Display option) Display entire ClassAds 
      (same as \Opt{-verbose}).}
    \OptItem{\OptArg{-sort}{expr}}{(Display option) Change the display order
      to be based on ascending values of an evaluated expression 
      given by \Arg{expr}.
      Evaluated expressions of a string type are in a case insensitive
      alphabetical order.
      If multiple \Opt{-sort} arguments appear on the command line,
      the primary sort will be on the leftmost one within the command line,
      and it is numbered 0.  
      A secondary sort will be based on the second expression,
      and it is numbered 1.
      For informational or debugging purposes, the ClassAd output to be 
      displayed will appear as if the ClassAd had two additional attributes.
      \AdAttr{CondorStatusSortKeyExpr<N>} is the expression,
      where \Expr{<N>} is replaced by the number of the sort.
      \AdAttr{CondorStatusSortKey<N>}
      gives the result of evaluating the sort expression that is numbered
      \Expr{<N>}.}
    \OptItem{\Opt{-total}}{(Display option) Display totals only.}
    \OptItem{\Opt{-verbose}}{(Display option) Display entire ClassAds.  Implies
      that totals will not be displayed.}
    \OptItem{\Opt{-xml}}{(Display option) Display entire ClassAds,
      in XML format.  
      The XML format is fully defined in the reference manual,
      obtained from the ClassAds web page, with a link at
      \URL{http://htcondor.org/classad/classad.html}.}
    \OptItem{\OptArg{-constraint}{const}}{(Custom option) Add constraint 
      expression.  }
    \OptItem{\OptArg{-format}{fmt attr}}{(Custom option) Display attribute
      or expression \Arg{attr} in format \Arg{fmt}.
      To display the attribute or expression the format must contain a single
      \Code{printf(3)}-style conversion specifier.
      Attributes must be from the resource ClassAd.
      Expressions are ClassAd expressions and may
      refer to attributes in the resource ClassAd.
      If the attribute is not present in a given ClassAd and cannot 
      be parsed as an expression, then the
      format option will be silently skipped.
      \%r prints the unevaluated, or raw values.
      The conversion specifier must match the type of the
      attribute or expression.
      \%s is suitable for strings such as \Attr{Name},
      \%d for integers such as \Attr{LastHeardFrom},
      and \%f for floating point numbers such as \Attr{LoadAvg}.
      \%v identifies the type of the attribute, 
      and then prints the value in an appropriate format.
      \%V identifies the type of the attribute, 
      and then prints the value in an appropriate format as it would
      appear in the \Opt{-long} format.
      As an example, strings used with \%V will have quote marks.
      An incorrect format will result in undefined behavior.
      Do not use more than one conversion specifier in a given
      format.  More than one conversion specifier will result
      in undefined behavior.  To output multiple attributes
      repeat the \Opt{-format} option once for each desired
      attribute.
      Like \Code{printf(3)}-style formats, one may include other
      text that will be reproduced directly.
      A format without any conversion specifiers may be specified,
      but an attribute is still required.
      Include \Bs n to specify a line break. }


  \OptItem{\OptArg{-autoformat[:lhVr,tng]}{attr1 [attr2 ...]} 
  or \OptArg{-af[:lhVr,tng]}{attr1 [attr2 ...]}} {
    (Output option) Display attribute(s) or expression(s)
    formatted in a default way according to attribute types.  
    This option takes an arbitrary number of attribute names as arguments,
    and prints out their values, 
    with a space between each value and a newline character after 
    the last value.  
    It is like the \Opt{-format} option without format strings.
    This output option does \emph{not} work in conjunction with the
    \Opt{-run} option.

    It is assumed that no attribute names begin with a dash character,
    so that the next word that begins with dash is the 
    start of the next option.
    The \Opt{autoformat} option may be followed by a colon character
    and formatting qualifiers to deviate the output formatting from
    the default:

    \textbf{l} label each field,

    \textbf{h} print column headings before the first line of output,

    \textbf{V} use \%V rather than \%v for formatting (string values
    are quoted),

    \textbf{r} print "raw", or unevaluated values,

    \textbf{,} add a comma character after each field,

    \textbf{t} add a tab character before each field instead of 
    the default space character,

    \textbf{n} add a newline character after each field,

    \textbf{g} add a newline character between ClassAds, and
    suppress spaces before each field.

    Use \textbf{-af:h} to get tabular values with headings.

    Use \textbf{-af:lrng} to get -long equivalent format.

    The newline and comma characters may \emph{not} be used together.
    The \textbf{l} and \textbf{h} characters may \emph{not} be used
    together.
    }
    \OptItem{\OptArg{-target}{filename}}{(Custom option) Where evaluation
      requires a target ClassAd to evaluate against, file \Arg{filename}
      contains the target ClassAd.  }
\end{Options}

\GenRem
\begin{itemize}
	\item The default output from \Condor{status} is formatted to
	be human readable, not script readable.
	In an effort to make the output fit within 80 characters,
	values in some fields might be truncated.
	Furthermore, the HTCondor Project can (and does) change the
	formatting of this default output as we see fit.
	Therefore, any script that is attempting to parse data from
	\Condor{status} is strongly encouraged to use the
	\Opt{-format} option (described above).

	\item The information obtained from \Condor{startd} and \Condor{schedd}
	daemons
	may sometimes appear to be inconsistent.  This is normal since
	\Condor{startd}  and \Condor{schedd} daemons update the HTCondor
	manager at different rates, and since there is a
	delay as information propagates through the network and the system.

	\item Note that the \texttt{ActivityTime} in the \texttt{Idle} state is
	\emph{not} the amount of time that the machine has been idle.  See the
	section on \Condor{startd} states in the \emph{Administrator's Manual}
	for more information.

	\item When using \Condor{status} on a pool with SMP machines,
	you can either provide the host name, in which case you will
	get back information about all slots that are represented on
	that host, or you can list specific slots by name.
	See the examples below for details.

	\item If you specify host names, without domains, HTCondor will
	automatically try to resolve those host names into fully
	qualified host names for you.
	This also works when specifying specific nodes of an SMP
	machine.
	In this case, everything after the ``@'' sign is treated as a
	host name and that is what is resolved.

	\item You can use the \Opt{-direct} option in conjunction with
	almost any other set of options.
	However, at this time, the only daemon that will allow direct
	queries for its ad(s) is the \Condor{startd}.
	So, the only options currently not supported with
	\Opt{-direct} are \Opt{-schedd} and \Opt{-master}.
	Most other options use startd ads for their information, so
	they work seamlessly with \Opt{-direct}.
	The only other restriction on \Opt{-direct} is that you may
	only use 1 \Opt{-direct} option at a time.
	If you want to query information directly from multiple hosts,
	you must run \Condor{status} multiple times.

	\item Unless you use the local host name with \Opt{-direct},
	\Condor{status} will still have to contact a collector to find
	the address where the specified daemon is listening.
	So, using a \Opt{-pool} option in conjunction with
	\Opt{-direct} just tells \Condor{status} which collector to
	query to find the address of the daemon you want.
	The information actually displayed will still be retrieved
	directly from the daemon you specified as the argument to
	\Opt{-direct}.

\end{itemize}

\Examples

\underline{Example 1} To view information from all nodes of an SMP
machine, use only the host name.
For example, if you had a 4-CPU machine, named
\File{vulture.cs.wisc.edu}, you might see
\footnotesize
\begin{verbatim}
% condor_status vulture

Name               OpSys      Arch   State     Activity LoadAv Mem   ActvtyTime

slot1@vulture.cs.w LINUX      INTEL  Claimed   Busy     1.050   512  0+01:47:42
slot2@vulture.cs.w LINUX      INTEL  Claimed   Busy     1.000   512  0+01:48:19
slot3@vulture.cs.w LINUX      INTEL  Unclaimed Idle     0.070   512  1+11:05:32
slot4@vulture.cs.w LINUX      INTEL  Unclaimed Idle     0.000   512  1+11:05:34

                     Total Owner Claimed Unclaimed Matched Preempting Backfill

         INTEL/LINUX     4     0       2         2       0          0        0

               Total     4     0       2         2       0          0        0
\end{verbatim}
\normalsize


\underline{Example 2} To view information from a specific nodes of an
SMP machine, specify the node directly.
You do this by providing the name of the slot.
This has the form \texttt{slot\#@hostname}.
For example:
\footnotesize
\begin{verbatim}
% condor_status slot3@vulture

Name               OpSys      Arch   State     Activity LoadAv Mem   ActvtyTime

slot3@vulture.cs.w LINUX      INTEL  Unclaimed Idle     0.070   512  1+11:10:32

                     Total Owner Claimed Unclaimed Matched Preempting Backfill

         INTEL/LINUX     1     0       0         1       0          0        0

               Total     1     0       0         1       0          0        0
\end{verbatim}
\normalsize

\underline{Constraint option examples}

The Unix command
to use the constraint option to see all machines with the \Attr{OpSys}
of \AdStr{LINUX}:
\begin{verbatim}
% condor_status -constraint OpSys==\"LINUX\"
\end{verbatim}
Note that quotation marks must be escaped with the backslash characters
for most shells.

The Windows command to do the same thing:
\begin{verbatim}
>condor_status -constraint " OpSys==""LINUX"" "
\end{verbatim}
Note that quotation marks are used to delimit the single argument which
is the expression, and the quotation marks that identify the string
must be escaped by using a set of two double quote marks without
any intervening spaces.

To see all machines that are currently in the Idle state,
the Unix command is
\begin{verbatim}
% condor_status -constraint State==\"Idle\"
\end{verbatim}

To see all machines that are bench marked to have a MIPS rating
of more than 750, the Unix command is
\begin{verbatim}
% condor_status -constraint 'Mips>750' 
\end{verbatim}

\underline{-cod option example}

The \Opt{-cod} option displays the status of COD
claims within a given HTCondor pool. 

\footnotesize
\begin{verbatim}
Name        ID   ClaimState TimeInState RemoteUser JobId Keyword
astro.cs.wi COD1 Idle        0+00:00:04 wright
chopin.cs.w COD1 Running     0+00:02:05 wright     3.0   fractgen
chopin.cs.w COD2 Suspended   0+00:10:21 wright     4.0   fractgen

               Total  Idle  Running  Suspended  Vacating  Killing
 INTEL/LINUX       3     1        1          1         0        0
       Total       3     1        1          1         0        0
\end{verbatim}
\normalsize

\underline{-format option example}
To display the name and memory attributes of each job ClassAd in a format
that is easily parsable by other tools:
\begin{verbatim}
% condor_status -format "%s " Name -format "%d\n" Memory
\end{verbatim}
To do the same with the \Opt{autoformat} option, run
\begin{verbatim}
% condor_status -autoformat Name Memory
\end{verbatim}


\ExitStatus

\Condor{status} will exit with a status value of 0 (zero) upon success,
and it will exit with the value 1 (one) upon failure.

\end{ManPage}

